require 'socket'
require 'thread'

port = if ARGV[0] then ARGV[0] else 12345 end
gate = TCPServer.open(port)
m = Mutex.new
srand

def gen_question(length)
  num = rand(9) + 1
  correct = num
  question = num.to_s
  (2..length).each {
    num = rand(9) + 1
    correct += num
    question += " + #{num}"
  }
  return correct, question
end

sock = nil
loop do
  sock = gate.accept

  # ҥץ
  break unless fork   # ҥץʤ롼פȴ

  # ƥץ -- ҥץνλԤäƼμդ
  Process.wait
end

# ҥץ -- ¹ץƽλ
gate.close     # ҥץǤϼΥåȤפʤΤĤ
exit! if fork  # ¹ץƽλ

# ¹ץ -- Фν
begin
  sock.write "Are you ready?\n"
  [5,4,3,2,1].each{|count|
    sleep 1
    sock.write "#{'.'*count} #{count}\n"
  }
rescue
  sock.close
end

answer = 0
th_read = Thread.start {
  while msg = sock.gets
    m.synchronize { answer = msg.chomp.to_i }
  end
}

th_write = Thread.start {
  sleep 1
  sock.write "Start !!\n"
  right = 0
  (1..12).each do |num|
    correct, question = gen_question( (num-1)/3 + 2 )
    m.synchronize { answer = 0 }
    sock.write("(#{num}) " + question + "\n")
    sleep 1
    [4,3,2,1].each do |cnt|
      sock.write "#{'.'*cnt} \n"
      sleep 1
    end
    m.synchronize { right += 1 if correct == answer }
  end
  sock.write "Finish !!\n"
  sock.write "You gave the #{right}/12 right answers.\n"
}

begin
  th_write.join
rescue
end
th_read.exit if th_read.alive?

sock.shutdown(1)  # ʾ奵ФϤʤȤ
sock.close        # åȤĤ
